/* RelevancyService.c generated by valac 0.56.2, the Vala compiler
 * generated from RelevancyService.vala, do not modify */

/*
 * This file is part of budgie-desktop
 *
 * Copyright Budgie Desktop Developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#include "budgie-appindexer.h"
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>

enum  {
	BUDGIE_RELEVANCY_SERVICE_0_PROPERTY,
	BUDGIE_RELEVANCY_SERVICE_NUM_PROPERTIES
};
static GParamSpec* budgie_relevancy_service_properties[BUDGIE_RELEVANCY_SERVICE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

static gpointer budgie_relevancy_service_parent_class = NULL;
static GeeHashMap* budgie_relevancy_service_scores;
static GeeHashMap* budgie_relevancy_service_scores = NULL;

static gint budgie_relevancy_service_get_levenshtein_distance (BudgieRelevancyService* self,
                                                        const gchar* s1,
                                                        const gchar* s2);
static gboolean budgie_relevancy_service_array_contains (BudgieRelevancyService* self,
                                                  gchar** array,
                                                  gint array_length1,
                                                  const gchar* term);
static gchar** _vala_array_dup3 (gchar** self,
                          gssize length);
static gboolean budgie_relevancy_service_is_default_handler (BudgieRelevancyService* self,
                                                      BudgieApplication* app);
static void budgie_relevancy_service_finalize (GObject * obj);
static GType budgie_relevancy_service_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

/**
* Return a string suitable for working on.
* This works around the issue of GNOME Control Center and others deciding to
* use soft hyphens in their .desktop files.
*/
static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		g_clear_error (&_inner_error0_);
		g_assert_not_reached ();
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	g_strstrip (_result_);
	result = _result_;
	return result;
}

gchar*
budgie_relevancy_service_searchable_string (const gchar* input)
{
	gchar* mod = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* result;
	g_return_val_if_fail (input != NULL, NULL);
	_tmp0_ = g_strconcat ("", input, NULL);
	mod = _tmp0_;
	_tmp1_ = string_replace (mod, "\u00AD", "");
	_tmp2_ = _tmp1_;
	_tmp3_ = g_utf8_casefold (_tmp2_, (gssize) -1);
	_tmp4_ = _tmp3_;
	_tmp5_ = string_strip (_tmp4_);
	_tmp6_ = _tmp5_;
	_g_free0 (_tmp4_);
	_g_free0 (_tmp2_);
	result = _tmp6_;
	_g_free0 (mod);
	return result;
}

/**
* Get the current relevancy score for an application.
*
* The lower the score, the more relevant it is.
*/
gint
budgie_relevancy_service_get_score (BudgieRelevancyService* self,
                                    BudgieApplication* app)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gpointer _tmp4_;
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (app != NULL, 0);
	_tmp0_ = budgie_relevancy_service_scores;
	if (_tmp0_ == NULL) {
		g_warning ("RelevancyService.vala:49: Relevancy HashMap has not been initialized!");
		result = G_MAXINT;
		return result;
	}
	_tmp1_ = budgie_relevancy_service_scores;
	_tmp2_ = budgie_application_get_desktop_id (app);
	_tmp3_ = _tmp2_;
	_tmp4_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp1_, _tmp3_);
	result = (gint) ((gintptr) _tmp4_);
	return result;
}

/**
* Check if an application's relevancy score is below our
* relevancy threshold.
*/
gboolean
budgie_relevancy_service_is_app_relevant (BudgieRelevancyService* self,
                                          BudgieApplication* app)
{
	GeeHashMap* _tmp0_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (app != NULL, FALSE);
	_tmp0_ = budgie_relevancy_service_scores;
	if (_tmp0_ == NULL) {
		g_warning ("RelevancyService.vala:62: Relevancy HashMap has not been initialized!");
		result = FALSE;
		return result;
	}
	result = budgie_relevancy_service_get_score (self, app) < BUDGIE_RELEVANCY_SERVICE_THRESHOLD;
	return result;
}

/**
* Clears our relevancy mappings.
*/
void
budgie_relevancy_service_reset (BudgieRelevancyService* self)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = budgie_relevancy_service_scores;
	if (_tmp0_ == NULL) {
		return;
	}
	_tmp1_ = budgie_relevancy_service_scores;
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp1_);
}

/**
* Determine a score in relation to a given search term.
*
* Somewhat unintuitively, the lower the score returned,
* the more relevant this item is. This is because we take
* the Levenshtein Distance between the term and the name
* into account, and it's way easier to have an arbitrary
* threshold when you have a set minimum value.
*
* This was inspired by prior art from Brisk Menu.
*/
static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

static gchar**
_vala_array_dup3 (gchar** self,
                  gssize length)
{
	if (length >= 0) {
		gchar** result;
		gssize i;
		result = g_new0 (gchar*, length + 1);
		for (i = 0; i < length; i++) {
			gchar* _tmp0_;
			_tmp0_ = g_strdup (self[i]);
			result[i] = _tmp0_;
		}
		return result;
	}
	return NULL;
}

void
budgie_relevancy_service_update_relevancy (BudgieRelevancyService* self,
                                           BudgieApplication* app,
                                           const gchar* term)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* name = NULL;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _term = NULL;
	gchar* _tmp7_;
	gint score = 0;
	gboolean _tmp8_ = FALSE;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar** fields = NULL;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	gchar* _tmp20_;
	const gchar* _tmp21_;
	const gchar* _tmp22_;
	gchar* _tmp23_;
	gchar** _tmp24_;
	gint fields_length1;
	gint _fields_size_;
	gchar** _tmp25_;
	gint _tmp25__length1;
	const gchar* _tmp26_;
	gchar** keywords = NULL;
	gchar** _tmp28_;
	gint _tmp28__length1;
	gint _tmp29_ = 0;
	gchar** _tmp30_;
	gint _tmp30__length1;
	gchar** _tmp31_;
	gint _tmp31__length1;
	gint keywords_length1;
	gint _keywords_size_;
	gboolean _tmp32_ = FALSE;
	gchar** _tmp33_;
	gint _tmp33__length1;
	gboolean _tmp38_ = FALSE;
	const gchar* _tmp39_;
	const gchar* _tmp40_;
	GeeHashMap* _tmp44_;
	const gchar* _tmp45_;
	const gchar* _tmp46_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (app != NULL);
	g_return_if_fail (term != NULL);
	_tmp0_ = budgie_relevancy_service_scores;
	if (_tmp0_ == NULL) {
		g_warning ("RelevancyService.vala:93: Relevancy HashMap has not been initialized!");
		return;
	}
	_tmp1_ = budgie_relevancy_service_scores;
	_tmp2_ = budgie_application_get_desktop_id (app);
	_tmp3_ = _tmp2_;
	gee_abstract_map_unset ((GeeAbstractMap*) _tmp1_, _tmp3_, NULL);
	if (g_strcmp0 (term, "") == 0) {
		return;
	}
	_tmp4_ = budgie_application_get_name (app);
	_tmp5_ = _tmp4_;
	_tmp6_ = budgie_relevancy_service_searchable_string (_tmp5_);
	name = _tmp6_;
	_tmp7_ = g_utf8_casefold (term, (gssize) -1);
	_term = _tmp7_;
	score = 0;
	_tmp9_ = name;
	_tmp10_ = _term;
	if (!g_str_match_string (_tmp9_, _tmp10_, TRUE)) {
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		_tmp11_ = name;
		_tmp12_ = _term;
		_tmp8_ = !string_contains (_tmp11_, _tmp12_);
	} else {
		_tmp8_ = FALSE;
	}
	if (_tmp8_) {
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		_tmp13_ = name;
		_tmp14_ = _term;
		score = budgie_relevancy_service_get_levenshtein_distance (self, _tmp13_, _tmp14_);
	}
	_tmp15_ = budgie_application_get_generic_name (app);
	_tmp16_ = _tmp15_;
	_tmp17_ = g_strdup (_tmp16_);
	_tmp18_ = budgie_application_get_description (app);
	_tmp19_ = _tmp18_;
	_tmp20_ = g_strdup (_tmp19_);
	_tmp21_ = budgie_application_get_exec (app);
	_tmp22_ = _tmp21_;
	_tmp23_ = g_strdup (_tmp22_);
	_tmp24_ = g_new0 (gchar*, 3 + 1);
	_tmp24_[0] = _tmp17_;
	_tmp24_[1] = _tmp20_;
	_tmp24_[2] = _tmp23_;
	fields = _tmp24_;
	fields_length1 = 3;
	_fields_size_ = fields_length1;
	_tmp25_ = fields;
	_tmp25__length1 = fields_length1;
	_tmp26_ = _term;
	if (budgie_relevancy_service_array_contains (self, _tmp25_, (gint) _tmp25__length1, _tmp26_)) {
		gint _tmp27_;
		_tmp27_ = score;
		score = _tmp27_ - 1;
	}
	_tmp28_ = budgie_application_get_keywords (app, &_tmp29_);
	_tmp28__length1 = _tmp29_;
	_tmp30_ = _tmp28_;
	_tmp30__length1 = _tmp28__length1;
	_tmp31_ = (_tmp30_ != NULL) ? _vala_array_dup3 (_tmp30_, _tmp30__length1) : _tmp30_;
	_tmp31__length1 = _tmp30__length1;
	keywords = _tmp31_;
	keywords_length1 = _tmp31__length1;
	_keywords_size_ = keywords_length1;
	_tmp33_ = keywords;
	_tmp33__length1 = keywords_length1;
	if (_tmp33_ != NULL) {
		gchar** _tmp34_;
		gint _tmp34__length1;
		_tmp34_ = keywords;
		_tmp34__length1 = keywords_length1;
		_tmp32_ = _tmp34__length1 > 0;
	} else {
		_tmp32_ = FALSE;
	}
	if (_tmp32_) {
		gchar** _tmp35_;
		gint _tmp35__length1;
		const gchar* _tmp36_;
		_tmp35_ = keywords;
		_tmp35__length1 = keywords_length1;
		_tmp36_ = _term;
		if (budgie_relevancy_service_array_contains (self, _tmp35_, (gint) _tmp35__length1, _tmp36_)) {
			gint _tmp37_;
			_tmp37_ = score;
			score = _tmp37_ - 1;
		}
	}
	_tmp39_ = name;
	_tmp40_ = _term;
	if (string_contains (_tmp39_, _tmp40_)) {
		_tmp38_ = budgie_relevancy_service_is_default_handler (self, app);
	} else {
		_tmp38_ = FALSE;
	}
	if (_tmp38_) {
		const gchar* _tmp41_;
		const gchar* _tmp42_;
		gint _tmp43_;
		_tmp41_ = budgie_application_get_name (app);
		_tmp42_ = _tmp41_;
		g_debug ("RelevancyService.vala:139: Application '%s' is default handler", _tmp42_);
		_tmp43_ = score;
		score = _tmp43_ - 1;
	}
	_tmp44_ = budgie_relevancy_service_scores;
	_tmp45_ = budgie_application_get_desktop_id (app);
	_tmp46_ = _tmp45_;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp44_, _tmp46_, (gpointer) ((gintptr) score));
	keywords = (_vala_array_free (keywords, keywords_length1, (GDestroyNotify) g_free), NULL);
	fields = (_vala_array_free (fields, fields_length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (_term);
	_g_free0 (name);
}

/**
* Calculates the Levenshtein Distance between two strings.
*
* The lower the returned score, the closer the match.
*
* This was adapted from https://gist.github.com/Davidblkx/e12ab0bb2aff7fd8072632b396538560,
* an implementation in C#.
*/
static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
	g_return_val_if_fail (self != NULL, '\0');
	_tmp0_ = ((gchar*) self)[index];
	result = _tmp0_;
	return result;
}

static gint
budgie_relevancy_service_get_levenshtein_distance (BudgieRelevancyService* self,
                                                   const gchar* s1,
                                                   const gchar* s2)
{
	gint* matrix = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint* _tmp4_;
	gint matrix_length1;
	gint matrix_length2;
	gint _tmp5_;
	gint _tmp6_;
	gint* _tmp41_;
	gint _tmp41__length1;
	gint _tmp41__length2;
	gint _tmp42_;
	gint _tmp43_;
	gint _tmp44_;
	gint _tmp45_;
	gint _tmp46_;
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (s1 != NULL, 0);
	g_return_val_if_fail (s2 != NULL, 0);
	_tmp0_ = strlen (s1);
	_tmp1_ = _tmp0_;
	_tmp2_ = strlen (s2);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_new0 (gint, (_tmp1_ + 1) * (_tmp3_ + 1));
	matrix = _tmp4_;
	matrix_length1 = _tmp1_ + 1;
	matrix_length2 = _tmp3_ + 1;
	_tmp5_ = strlen (s1);
	_tmp6_ = _tmp5_;
	if (_tmp6_ == 0) {
		gint _tmp7_;
		gint _tmp8_;
		_tmp7_ = strlen (s2);
		_tmp8_ = _tmp7_;
		result = _tmp8_;
		matrix = (g_free (matrix), NULL);
		return result;
	} else {
		gint _tmp9_;
		gint _tmp10_;
		_tmp9_ = strlen (s2);
		_tmp10_ = _tmp9_;
		if (_tmp10_ == 0) {
			gint _tmp11_;
			gint _tmp12_;
			_tmp11_ = strlen (s1);
			_tmp12_ = _tmp11_;
			result = _tmp12_;
			matrix = (g_free (matrix), NULL);
			return result;
		}
	}
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp13_ = FALSE;
			_tmp13_ = TRUE;
			while (TRUE) {
				gint _tmp17_;
				gint _tmp18_;
				if (!_tmp13_) {
					gint* _tmp14_;
					gint _tmp14__length1;
					gint _tmp14__length2;
					gint _tmp15_;
					gint _tmp16_;
					_tmp14_ = matrix;
					_tmp14__length1 = matrix_length1;
					_tmp14__length2 = matrix_length2;
					_tmp15_ = i;
					_tmp16_ = i;
					i = _tmp16_ + 1;
					_tmp14_[(_tmp15_ * _tmp14__length2) + 0] = _tmp16_;
				}
				_tmp13_ = FALSE;
				_tmp17_ = strlen (s1);
				_tmp18_ = _tmp17_;
				if (!(i <= _tmp18_)) {
					break;
				}
			}
		}
	}
	{
		gint j = 0;
		j = 0;
		{
			gboolean _tmp19_ = FALSE;
			_tmp19_ = TRUE;
			while (TRUE) {
				gint _tmp23_;
				gint _tmp24_;
				if (!_tmp19_) {
					gint* _tmp20_;
					gint _tmp20__length1;
					gint _tmp20__length2;
					gint _tmp21_;
					gint _tmp22_;
					_tmp20_ = matrix;
					_tmp20__length1 = matrix_length1;
					_tmp20__length2 = matrix_length2;
					_tmp21_ = j;
					_tmp22_ = j;
					j = _tmp22_ + 1;
					_tmp20_[(0 * _tmp20__length2) + _tmp21_] = _tmp22_;
				}
				_tmp19_ = FALSE;
				_tmp23_ = strlen (s2);
				_tmp24_ = _tmp23_;
				if (!(j <= _tmp24_)) {
					break;
				}
			}
		}
	}
	{
		gint i = 0;
		i = 1;
		{
			gboolean _tmp25_ = FALSE;
			_tmp25_ = TRUE;
			while (TRUE) {
				gint _tmp27_;
				gint _tmp28_;
				if (!_tmp25_) {
					gint _tmp26_;
					_tmp26_ = i;
					i = _tmp26_ + 1;
				}
				_tmp25_ = FALSE;
				_tmp27_ = strlen (s1);
				_tmp28_ = _tmp27_;
				if (!(i <= _tmp28_)) {
					break;
				}
				{
					gint j = 0;
					j = 1;
					{
						gboolean _tmp29_ = FALSE;
						_tmp29_ = TRUE;
						while (TRUE) {
							gint _tmp31_;
							gint _tmp32_;
							gint _tmp33_ = 0;
							gint cost = 0;
							gint* _tmp34_;
							gint _tmp34__length1;
							gint _tmp34__length2;
							gint* _tmp35_;
							gint _tmp35__length1;
							gint _tmp35__length2;
							gint _tmp36_;
							gint* _tmp37_;
							gint _tmp37__length1;
							gint _tmp37__length2;
							gint _tmp38_;
							gint* _tmp39_;
							gint _tmp39__length1;
							gint _tmp39__length2;
							gint _tmp40_;
							if (!_tmp29_) {
								gint _tmp30_;
								_tmp30_ = j;
								j = _tmp30_ + 1;
							}
							_tmp29_ = FALSE;
							_tmp31_ = strlen (s2);
							_tmp32_ = _tmp31_;
							if (!(j <= _tmp32_)) {
								break;
							}
							if (string_get (s2, (glong) (j - 1)) == string_get (s1, (glong) (i - 1))) {
								_tmp33_ = 0;
							} else {
								_tmp33_ = 1;
							}
							cost = _tmp33_;
							_tmp34_ = matrix;
							_tmp34__length1 = matrix_length1;
							_tmp34__length2 = matrix_length2;
							_tmp35_ = matrix;
							_tmp35__length1 = matrix_length1;
							_tmp35__length2 = matrix_length2;
							_tmp36_ = _tmp35_[((i - 1) * _tmp35__length2) + j];
							_tmp37_ = matrix;
							_tmp37__length1 = matrix_length1;
							_tmp37__length2 = matrix_length2;
							_tmp38_ = _tmp37_[(i * _tmp37__length2) + (j - 1)];
							_tmp39_ = matrix;
							_tmp39__length1 = matrix_length1;
							_tmp39__length2 = matrix_length2;
							_tmp40_ = _tmp39_[((i - 1) * _tmp39__length2) + (j - 1)];
							_tmp34_[(i * _tmp34__length2) + j] = MIN (MIN (_tmp36_ + 1, _tmp38_ + 1), _tmp40_ + cost);
						}
					}
				}
			}
		}
	}
	_tmp41_ = matrix;
	_tmp41__length1 = matrix_length1;
	_tmp41__length2 = matrix_length2;
	_tmp42_ = strlen (s1);
	_tmp43_ = _tmp42_;
	_tmp44_ = strlen (s2);
	_tmp45_ = _tmp44_;
	_tmp46_ = _tmp41_[(_tmp43_ * _tmp41__length2) + _tmp45_];
	result = _tmp46_;
	matrix = (g_free (matrix), NULL);
	return result;
}

static gboolean
budgie_relevancy_service_array_contains (BudgieRelevancyService* self,
                                         gchar** array,
                                         gint array_length1,
                                         const gchar* term)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (term != NULL, FALSE);
	{
		gchar** field_collection = NULL;
		gint field_collection_length1 = 0;
		gint _field_collection_size_ = 0;
		gint field_it = 0;
		field_collection = array;
		field_collection_length1 = array_length1;
		for (field_it = 0; field_it < field_collection_length1; field_it = field_it + 1) {
			gchar* _tmp0_;
			gchar* field = NULL;
			_tmp0_ = g_strdup (field_collection[field_it]);
			field = _tmp0_;
			{
				const gchar* _tmp1_;
				gchar* ct = NULL;
				const gchar* _tmp2_;
				gchar* _tmp3_;
				const gchar* _tmp4_;
				const gchar* _tmp5_;
				_tmp1_ = field;
				if (_tmp1_ == NULL) {
					_g_free0 (field);
					continue;
				}
				_tmp2_ = field;
				_tmp3_ = budgie_relevancy_service_searchable_string (_tmp2_);
				ct = _tmp3_;
				_tmp4_ = ct;
				if (g_str_match_string (term, _tmp4_, TRUE)) {
					result = TRUE;
					_g_free0 (ct);
					_g_free0 (field);
					return result;
				}
				_tmp5_ = ct;
				if (string_contains (_tmp5_, term)) {
					result = TRUE;
					_g_free0 (ct);
					_g_free0 (field);
					return result;
				}
				_g_free0 (ct);
				_g_free0 (field);
			}
		}
	}
	result = FALSE;
	return result;
}

/**
 * Check if an application is the default handler for
 * any of its supported MIME types.
 */
static gboolean
budgie_relevancy_service_is_default_handler (BudgieRelevancyService* self,
                                             BudgieApplication* app)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
	gint _tmp1_ = 0;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (app != NULL, FALSE);
	_tmp0_ = budgie_application_get_content_types (app, &_tmp1_);
	_tmp0__length1 = _tmp1_;
	_tmp2_ = _tmp0_;
	_tmp2__length1 = _tmp0__length1;
	{
		gchar** content_type_collection = NULL;
		gint content_type_collection_length1 = 0;
		gint _content_type_collection_size_ = 0;
		gint content_type_it = 0;
		content_type_collection = _tmp2_;
		content_type_collection_length1 = _tmp2__length1;
		for (content_type_it = 0; content_type_it < content_type_collection_length1; content_type_it = content_type_it + 1) {
			gchar* _tmp3_;
			gchar* content_type = NULL;
			_tmp3_ = g_strdup (content_type_collection[content_type_it]);
			content_type = _tmp3_;
			{
				GAppInfo* default_app = NULL;
				const gchar* _tmp4_;
				GAppInfo* _tmp5_;
				GAppInfo* _tmp6_;
				GAppInfo* _tmp7_;
				const gchar* _tmp8_;
				const gchar* _tmp9_;
				const gchar* _tmp10_;
				_tmp4_ = content_type;
				_tmp5_ = g_app_info_get_default_for_type (_tmp4_, FALSE);
				default_app = _tmp5_;
				_tmp6_ = default_app;
				if (_tmp6_ == NULL) {
					_g_object_unref0 (default_app);
					_g_free0 (content_type);
					continue;
				}
				_tmp7_ = default_app;
				_tmp8_ = g_app_info_get_id (_tmp7_);
				_tmp9_ = budgie_application_get_desktop_id (app);
				_tmp10_ = _tmp9_;
				if (g_strcmp0 (_tmp8_, _tmp10_) == 0) {
					result = TRUE;
					_g_object_unref0 (default_app);
					_g_free0 (content_type);
					return result;
				}
				_g_object_unref0 (default_app);
				_g_free0 (content_type);
			}
		}
	}
	result = FALSE;
	return result;
}

BudgieRelevancyService*
budgie_relevancy_service_construct (GType object_type)
{
	BudgieRelevancyService * self = NULL;
	self = (BudgieRelevancyService*) g_object_new (object_type, NULL);
	return self;
}

BudgieRelevancyService*
budgie_relevancy_service_new (void)
{
	return budgie_relevancy_service_construct (BUDGIE_TYPE_RELEVANCY_SERVICE);
}

static void
budgie_relevancy_service_class_init (BudgieRelevancyServiceClass * klass,
                                     gpointer klass_data)
{
	GeeHashMap* _tmp0_;
	budgie_relevancy_service_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = budgie_relevancy_service_finalize;
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_INT, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (budgie_relevancy_service_scores);
	budgie_relevancy_service_scores = _tmp0_;
}

static void
budgie_relevancy_service_instance_init (BudgieRelevancyService * self,
                                        gpointer klass)
{
}

static void
budgie_relevancy_service_finalize (GObject * obj)
{
	BudgieRelevancyService * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BUDGIE_TYPE_RELEVANCY_SERVICE, BudgieRelevancyService);
	G_OBJECT_CLASS (budgie_relevancy_service_parent_class)->finalize (obj);
}

/**
* This class keeps track of how relevant each application
* in the menu is with relation to a search term.
*/
static GType
budgie_relevancy_service_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BudgieRelevancyServiceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) budgie_relevancy_service_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BudgieRelevancyService), 0, (GInstanceInitFunc) budgie_relevancy_service_instance_init, NULL };
	GType budgie_relevancy_service_type_id;
	budgie_relevancy_service_type_id = g_type_register_static (G_TYPE_OBJECT, "BudgieRelevancyService", &g_define_type_info, 0);
	return budgie_relevancy_service_type_id;
}

GType
budgie_relevancy_service_get_type (void)
{
	static volatile gsize budgie_relevancy_service_type_id__once = 0;
	if (g_once_init_enter (&budgie_relevancy_service_type_id__once)) {
		GType budgie_relevancy_service_type_id;
		budgie_relevancy_service_type_id = budgie_relevancy_service_get_type_once ();
		g_once_init_leave (&budgie_relevancy_service_type_id__once, budgie_relevancy_service_type_id);
	}
	return budgie_relevancy_service_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

